Index: /trunk/src/objects/RpParserXML.h
===================================================================
--- /trunk/src/objects/RpParserXML.h	(revision 1560)
+++ /trunk/src/objects/RpParserXML.h	(revision 1560)
@@ -0,0 +1,54 @@
+/*
+ * ======================================================================
+ *  AUTHOR:  Derrick Kearney, Purdue University
+ *  Copyright (c) 2005-2009  Purdue Research Foundation
+ *
+ *  See the file "license.terms" for information on usage and
+ *  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+ * ======================================================================
+ */
+#include <errno.h>
+#include <expat.h>
+#include <string.h>
+#include "RpTree.h"
+#include "RpChain.h"
+
+#ifndef RAPPTURE_PARSER_XML_H
+#define RAPPTURE_PARSER_XML_H
+
+#define PARSERXML_LEVEL_WIDTH 4
+
+enum RapptureParserXmlFlags {
+    RPXML_CREATE=(1<<0),    /* Create the xml path if needed. */
+    RPXML_APPEND=(1<<1),    /* Append data to the data already available. */
+};
+
+
+typedef struct Rp_ParserXmlStruct Rp_ParserXml;
+
+Rp_ParserXml *Rp_ParserXmlCreate();
+void Rp_ParserXmlDestroy(Rp_ParserXml **p);
+
+void Rp_ParserXmlParse(Rp_ParserXml *p, const char *xml);
+Rp_TreeNode Rp_ParserXmlSearch( Rp_ParserXml *p, const char *path, int create);
+const char *Rp_ParserXmlGet(Rp_ParserXml *p, const char *path);
+void Rp_ParserXmlPut(Rp_ParserXml *p, const char *path, const char *val,
+    int append);
+
+Rp_Tree Rp_ParserXmlTreeClient(Rp_ParserXml *p);
+
+Rp_TreeNode Rp_ParserXmlElement(Rp_ParserXml *p, const char *path);
+Rp_TreeNode Rp_ParserXmlParent(Rp_ParserXml *p, const char *path);
+size_t Rp_ParserXmlChildren(Rp_ParserXml *p, const char *path,
+    const char *type, Rp_Chain *children);
+size_t Rp_ParserXmlNumberChildren(Rp_ParserXml *p, const char *path,
+    const char *type);
+void Rp_ParserXmlBaseNode(Rp_ParserXml *p, Rp_TreeNode node);
+
+// const char *Rp_ParserXmlNodePath(Rp_ParserXml *p, Rp_TreeNode node);
+const char *Rp_ParserXmlNodeId(Rp_ParserXml *p, Rp_TreeNode node);
+
+const char *Rp_ParserXmlXml(Rp_ParserXml *p);
+const char *Rp_ParserXmlPathVal(Rp_ParserXml *p);
+
+#endif // RAPPTURE_PARSER_XML_H
Index: /trunk/src/objects/RpPath.cc
===================================================================
--- /trunk/src/objects/RpPath.cc	(revision 1559)
+++ /trunk/src/objects/RpPath.cc	(revision 1560)
@@ -23,4 +23,5 @@
 #include "RpChainHelper.h"
 #include <cstring>
+#include <cstdlib>
 
 using namespace Rappture;
@@ -60,4 +61,5 @@
     _ifs = b._ifs;
 
+    //FIXME: i think this is broken
     Rp_ChainCopy (_pathList, b._pathList, Rp_ChainCharCpyFxn);
 }
@@ -105,4 +107,5 @@
     _ifs = '.';
     _pathList = Rp_ChainCreate();
+    _currLink = Rp_ChainFirstLink(_pathList);
     return;
 }
@@ -134,5 +137,6 @@
     int end,
     int idOpenParen,
-    int idCloseParen)
+    int idCloseParen,
+    size_t degree)
 {
     componentStruct *c = new componentStruct();
@@ -143,4 +147,5 @@
     c->type = NULL;
     c->id = NULL;
+    c->degree = degree;
 
     if (idOpenParen < idCloseParen) {
@@ -171,5 +176,5 @@
         the type and id of the third component are both blank.
         for the above example paths, the id field of the first
-        components, the index component, is NULL.
+        components, the input component, is NULL.
         i don't think there is a way to get a NULL type right now.
     */
@@ -215,4 +220,6 @@
     int idCloseParen = -1;
     componentStruct *c = NULL;
+    size_t degree = 1;
+    char *newEnd = NULL;
 
     Rp_Chain *compList = Rp_ChainCreate();
@@ -227,6 +234,20 @@
         } else if (p[end] == ')') {
             idCloseParen = end;
+        } else if ( (idOpenParen <= idCloseParen) &&
+                    (end != 0) &&
+                    (p[end] >= '0') &&
+                    (p[end] <= '9') ) {
+            degree = (size_t) strtod(p+end, &newEnd);
+            if (degree == 0) {
+                // interpret degree of 0 same as degree of 1
+                degree = 1;
+            }
+            // check if we consumed the _ifs
+            if (*(newEnd-1) == _ifs) {
+                newEnd -= 2;
+            }
+            end += newEnd - (p + end);
         } else if (p[end] == _ifs) {
-            c = __createComponent(p,start,end,idOpenParen,idCloseParen);
+            c = __createComponent(p,start,end,idOpenParen,idCloseParen,degree);
             if (c != NULL) {
                 Rp_ChainAppend(compList,c);
@@ -240,5 +261,5 @@
     }
 
-    c = __createComponent(p,start,end,idOpenParen,idCloseParen);
+    c = __createComponent(p,start,end,idOpenParen,idCloseParen,degree);
     if (c != NULL) {
         Rp_ChainAppend(compList,c);
@@ -335,10 +356,54 @@
 }
 
+bool
+Path::eof ()
+{
+    return (_currLink == NULL);
+}
+
+Path&
+Path::first ()
+{
+    _currLink = Rp_ChainFirstLink(_pathList);
+    return *this;
+}
+
+Path&
+Path::prev ()
+{
+    if (_currLink) {
+        _currLink = Rp_ChainPrevLink(_currLink);
+    }
+    return *this;
+}
+
+Path&
+Path::next ()
+{
+    if (_currLink) {
+        _currLink = Rp_ChainNextLink(_currLink);
+    }
+    return *this;
+}
+
+Path&
+Path::last ()
+{
+    _currLink = Rp_ChainLastLink(_pathList);
+    return *this;
+}
+
+size_t
+Path::count ()
+{
+    return Rp_ChainGetLength(_pathList);
+}
+
 const char *
 Path::component(void)
 {
     Rp_ChainLink *l = NULL;
-    size_t len = 0;
-
+
+    /*
     tmpBuf.clear();
 
@@ -348,5 +413,5 @@
     }
 
-    l = Rp_ChainLastLink(_pathList);
+    l = _currLink;
 
     if (l == NULL) {
@@ -363,19 +428,53 @@
 
     if (c->type != NULL) {
-        len = strlen(c->type);
-        if (len > 0) {
-            tmpBuf.append(c->type,len);
-        }
+        tmpBuf.appendf("%s",c->type);
+    }
+
+    if (c->degree != 1) {
+        tmpBuf.appendf("%zu",c->degree);
     }
 
     if (c->id != NULL) {
-        tmpBuf.append("(",1);
-        len = strlen(c->id);
-        if (len > 0) {
-            tmpBuf.append(c->id,len);
-        }
-        tmpBuf.append(")",1);
-    }
-
+        tmpBuf.appendf("(%s)",c->id);
+    }
+
+    // incase none of the above if statements are hit.
+    tmpBuf.append("\0",1);
+
+    return tmpBuf.bytes();
+    */
+
+
+    if (_pathList == NULL) {
+        return NULL;
+    }
+
+    l = _currLink;
+
+    if (l == NULL) {
+        return NULL;
+    }
+
+    componentStruct *c = (componentStruct *) Rp_ChainGetValue(l);
+
+    if (c == NULL) {
+        return NULL;
+    }
+
+    tmpBuf.clear();
+
+    if (c->type != NULL) {
+        tmpBuf.appendf("%s",c->type);
+    }
+
+    if (c->degree != 1) {
+        tmpBuf.appendf("%zu",c->degree);
+    }
+
+    if (c->id != NULL) {
+        tmpBuf.appendf("(%s)",c->id);
+    }
+
+    // incase none of the above if statements are hit.
     tmpBuf.append("\0",1);
 
@@ -426,15 +525,17 @@
     Rp_ChainDestroy(addList);
 
-    // remove the last component from the current path
-    l = Rp_ChainLastLink(_pathList);
+    // swap the current component from the current path
+    // with the component from the provided path.
+    l = _currLink;
 
     if (l != NULL) {
         componentStruct *last = (componentStruct *) Rp_ChainGetValue(l);
         delete last;
-        Rp_ChainDeleteLink(_pathList,l);
-    }
-
-    // append the new component onto the current path
-    Rp_ChainAppend(_pathList,aLcomp);
+        Rp_ChainSetValue(l,aLcomp);
+    } else {
+        // add a new component as a link
+        // point _currLink to the new component
+        _currLink = Rp_ChainAppend(_pathList,aLcomp);
+    }
 
     __updateBuffer();
@@ -448,4 +549,5 @@
     Rp_ChainLink *l = NULL;
 
+    /*
     tmpBuf.clear();
 
@@ -455,5 +557,5 @@
     }
 
-    l = Rp_ChainLastLink(_pathList);
+    l = _currLink;
 
     if (l == NULL) {
@@ -476,4 +578,23 @@
 
     return tmpBuf.bytes();
+    */
+
+    if (_pathList == NULL) {
+        return NULL;
+    }
+
+    l = _currLink;
+
+    if (l == NULL) {
+        return NULL;
+    }
+
+    componentStruct *c = (componentStruct *) Rp_ChainGetValue(l);
+
+    if (c == NULL) {
+        return NULL;
+    }
+
+    return c->id;
 }
 
@@ -490,6 +611,6 @@
     componentStruct *last = NULL;
 
-    // update the last component from the current path
-    l = Rp_ChainLastLink(_pathList);
+    // update the current component from the current path
+    l = _currLink;
 
     if (l != NULL) {
@@ -499,5 +620,5 @@
         // append the new component onto the current path
         last = new componentStruct;
-        Rp_ChainAppend(_pathList,last);
+        _currLink = Rp_ChainAppend(_pathList,last);
         tmp = new char[1];
         *tmp = '\0';
@@ -520,4 +641,5 @@
     Rp_ChainLink *l = NULL;
 
+    /*
     tmpBuf.clear();
 
@@ -527,5 +649,5 @@
     }
 
-    l = Rp_ChainLastLink(_pathList);
+    l = _currLink;
 
     if (l == NULL) {
@@ -548,4 +670,23 @@
 
     return tmpBuf.bytes();
+    */
+
+    if (_pathList == NULL) {
+        return NULL;
+    }
+
+    l = _currLink;
+
+    if (l == NULL) {
+        return NULL;
+    }
+
+    componentStruct *c = (componentStruct *) Rp_ChainGetValue(l);
+
+    if (c == NULL) {
+        return NULL;
+    }
+
+    return c->type;
 }
 
@@ -563,5 +704,5 @@
 
     // update the last component from the current path
-    l = Rp_ChainLastLink(_pathList);
+    l = _currLink;
 
     if (l != NULL) {
@@ -571,5 +712,5 @@
         // append the new component onto the current path
         last = new componentStruct;
-        Rp_ChainAppend(_pathList,last);
+        _currLink = Rp_ChainAppend(_pathList,last);
         last->id = NULL;
     }
@@ -593,5 +734,5 @@
     tmpBuf.clear();
 
-    last = Rp_ChainLastLink(_pathList);
+    last = _currLink;
     l = Rp_ChainFirstLink(_pathList);
     while (l != last) {
@@ -685,4 +826,53 @@
 }
 
+size_t
+Path::degree()
+{
+    Rp_ChainLink *l = NULL;
+
+    l = _currLink;
+
+    if (l == NULL) {
+        return 0;
+    }
+
+    componentStruct *c = (componentStruct *) Rp_ChainGetValue(l);
+
+    if (c == NULL) {
+        return 0;
+    }
+
+    return c->degree;
+}
+
+void
+Path::degree(size_t d)
+{
+    if (d == 0) {
+        d = 1;
+    }
+
+    Rp_ChainLink *l = NULL;
+    componentStruct *last = NULL;
+
+    // update the current component from the current path
+    l = _currLink;
+
+    if (l != NULL) {
+        last = (componentStruct *) Rp_ChainGetValue(l);
+    } else {
+        // append the new component onto the current path
+        last = new componentStruct;
+        _currLink = Rp_ChainAppend(_pathList,last);
+    }
+
+    // adjust the degree field
+    last->degree = d;
+
+    __updateBuffer();
+
+    return;
+}
+
 const char *
 Path::path(void)
@@ -696,4 +886,5 @@
     if (p != NULL) {
         _pathList = __parse(p);
+        _currLink = Rp_ChainLastLink(_pathList);
         __updateBuffer();
     }
Index: /trunk/src/objects/RpPath.h
===================================================================
--- /trunk/src/objects/RpPath.h	(revision 1559)
+++ /trunk/src/objects/RpPath.h	(revision 1560)
@@ -48,20 +48,31 @@
     Path& add(const char *el);  // turns input into input.number(blah)
     Path& del();                // turns input.number(blah) into input
+    bool eof();
+
+    Path& first();
+    Path& prev();
+    Path& next();
+    Path& last();
+    size_t count();
 
     // turns input.number(blah) into number(blah)
-    const char *component(void);    // get component of the path
-    void component(const char *p);  // set component of the path
+    const char *component(void);    // get component of the current component
+    void component(const char *p);  // set component of the current component
 
     // turns input.number(blah) into blah
-    const char *id(void);       // get the id of the path
-    void id(const char *p);     // set the id of the path
+    const char *id(void);       // get the id of the current component
+    void id(const char *p);     // set the id of the current component
 
     // turns input.number(blah) into number
-    const char *type(void);     // get the type of the path
-    void type(const char *p);   // set the type of the path
+    const char *type(void);     // get the type of the current component
+    void type(const char *p);   // set the type of the current component
 
     // turns input.number(blah) into input
-    const char *parent(void);   // get the parent of the path
-    void parent(const char *p); // set the parent of the path
+    const char *parent(void);   // get the parent of the current component
+    void parent(const char *p); // set the parent of the current component
+
+    // turns input.number2(blah) into 2
+    size_t degree(void);        // get the degree of the current component
+    void degree(size_t degree); // set the degree of the current component
 
     const char *path(void);     // get the path
@@ -73,4 +84,5 @@
         const char *type;
         const char *id;
+        size_t degree;
     } componentStruct;
 
@@ -80,9 +92,11 @@
     Rp_Chain *__parse(const char *p);
     componentStruct *__createComponent(const char *p, int start,
-                        int end, int idOpenParen, int idCloseParen);
+                        int end, int idOpenParen, int idCloseParen,
+                        size_t degree);
     void __deleteComponent(componentStruct *c);
 
     char _ifs;
     Rp_Chain *_pathList;
+    Rp_ChainLink *_currLink;
     SimpleCharBuffer b;
     SimpleCharBuffer tmpBuf;
Index: /trunk/src/objects/RpPlot.cc
===================================================================
--- /trunk/src/objects/RpPlot.cc	(revision 1559)
+++ /trunk/src/objects/RpPlot.cc	(revision 1560)
@@ -258,5 +258,5 @@
 
 const char *
-Plot::xml()
+Plot::xml(size_t indent, size_t tabstop)
 {
 
@@ -302,5 +302,5 @@
         }
 
-        _tmpBuf.append(c->xml());
+        _tmpBuf.append(c->xml(indent,tabstop));
         _tmpBuf.append("\n",1);
         l = Rp_ChainNextLink(l);
Index: /trunk/src/objects/RpPlot.h
===================================================================
--- /trunk/src/objects/RpPlot.h	(revision 1559)
+++ /trunk/src/objects/RpPlot.h	(revision 1560)
@@ -42,5 +42,5 @@
         Curve *getNthCurve(size_t n) const;
 
-        const char *xml();
+        const char *xml(size_t indent, size_t tabstop);
         const int is() const;
 
Index: /trunk/src/objects/RpScatter.cc
===================================================================
--- /trunk/src/objects/RpScatter.cc	(revision 1559)
+++ /trunk/src/objects/RpScatter.cc	(revision 1560)
@@ -23,4 +23,5 @@
     this->desc("");
     this->group("");
+    propstr("type","scatter");
 }
 
@@ -32,4 +33,5 @@
     this->desc("");
     this->group("");
+    propstr("type","scatter");
 }
 
@@ -42,4 +44,5 @@
     this->desc(desc);
     this->group(group);
+    propstr("type","scatter");
 }
 
@@ -71,6 +74,7 @@
  */
 
+/*
 const char *
-Scatter::xml()
+Scatter::xml(size_t indent, size_t tabstop)
 {
 // FIXME: the xml function should just read an array
@@ -122,4 +126,5 @@
     return _tmpBuf.bytes();
 }
+*/
 
 /**********************************************************************/
Index: /trunk/src/objects/RpScatter.h
===================================================================
--- /trunk/src/objects/RpScatter.h	(revision 1559)
+++ /trunk/src/objects/RpScatter.h	(revision 1560)
@@ -33,5 +33,5 @@
         virtual ~Scatter();
 
-        const char *xml();
+        // const char *xml();
         const int is() const;
 
Index: /trunk/src/objects/RpString.cc
===================================================================
--- /trunk/src/objects/RpString.cc	(revision 1559)
+++ /trunk/src/objects/RpString.cc	(revision 1560)
@@ -78,21 +78,26 @@
 
 const char *
-String::xml()
+String::xml(size_t indent, size_t tabstop)
 {
+    size_t l1width = indent + tabstop;
+    size_t l2width = indent + (2*tabstop);
+    const char *sp = "";
+
     Path p(path());
     _tmpBuf.clear();
 
     _tmpBuf.appendf(
-"<string id='%s'>\n\
-    <about>\n\
-        <label>%s</label>\n\
-        <description>%s</description>\n\
-        <hints>%s</hints>\n\
-    </about>\n\
-    <size>%ix%i</size>\n\
-    <default>%s</default>\n\
-    <current>%s</current>\n\
-</string>\n",
-       p.id(),label(),desc(),hints(),width(),height(),def(),cur());
+"%12$*9$s<string id='%1$s'>\n\
+%12$*10$s<about>\n\
+%12$*11$s<label>%2$s</label>\n\
+%12$*11$s<description>%3$s</description>\n\
+%12$*11$s<hints>%4$s</hints>\n\
+%12$*10$s</about>\n\
+%12$*10$s<size>%5$ix%6$i</size>\n\
+%12$*10$s<default>%7$s</default>\n\
+%12$*10$s<current>%8$s</current>\n\
+%12$*9$s</string>\n",
+       p.id(),label(),desc(),hints(),width(),height(),def(),cur(),
+       indent, l1width, l2width, sp);
 
     return _tmpBuf.bytes();
Index: /trunk/src/objects/RpString.h
===================================================================
--- /trunk/src/objects/RpString.h	(revision 1559)
+++ /trunk/src/objects/RpString.h	(revision 1560)
@@ -39,5 +39,5 @@
     Accessor<size_t> height;
 
-    const char *xml();
+    const char *xml(size_t indent, size_t tabstop);
     const int is() const;
 
Index: /trunk/src/objects/RpTree.c
===================================================================
--- /trunk/src/objects/RpTree.c	(revision 1559)
+++ /trunk/src/objects/RpTree.c	(revision 1560)
@@ -220,5 +220,5 @@
  */
 static Node *
-NewNode(TreeObject *treeObjPtr, CONST char *name, int inode)
+NewNode(TreeObject *treeObjPtr, CONST char *name, size_t inode)
 {
     Node *nodePtr;
@@ -840,5 +840,5 @@
     Node *nodePtr;  /* Node to be inserted. */
     TreeObject *treeObjPtr;
-    int inode;
+    size_t inode;
     int isNew;
 
@@ -890,5 +890,5 @@
                              * be inserted. */
     CONST char *name,       /* Name of node. */
-    int inode,              /* Requested id of the new node. If a
+    size_t inode,           /* Requested id of the new node. If a
                              * node by this id already exists in the
                              * tree, no node is created. */
@@ -1004,5 +1004,5 @@
 
 Rp_TreeNode
-Rp_TreeGetNode(TreeClient *clientPtr, unsigned int inode)
+Rp_TreeGetNode(TreeClient *clientPtr, size_t inode)
 {
     TreeObject *treeObjPtr = clientPtr->treeObject;
@@ -1099,4 +1099,32 @@
     label = Rp_TreeGetKey(string);
     for (nodePtr = parentPtr->first; nodePtr != NULL; nodePtr = nodePtr->next) {
+        if (label == nodePtr->label) {
+            return nodePtr;
+        }
+    }
+    return NULL;
+}
+
+/*
+ *----------------------------------------------------------------------
+ *
+ * Rp_TreeFindChildNext --
+ *
+ *  Searches for the next named node in a parent's chain of siblings.
+ *
+ *
+ * Results:
+ *  If found, the child node is returned, otherwise NULL.
+ *
+ *----------------------------------------------------------------------
+ */
+Rp_TreeNode
+Rp_TreeFindChildNext(Node *childPtr, CONST char *string)
+{
+    Rp_TreeKey label;
+    register Node *nodePtr;
+
+    label = Rp_TreeGetKey(string);
+    for (nodePtr = childPtr->next; nodePtr != NULL; nodePtr = nodePtr->next) {
         if (label == nodePtr->label) {
             return nodePtr;
@@ -1481,4 +1509,8 @@
 }
 
+/*
+ * commented out to avoid compiler warnings about function not being used
+ */
+/*
 static int
 ParseParentheses(
@@ -1487,6 +1519,7 @@
     char **rightPtr)
 {
-    register char *p;
-    char *left, *right;
+    register char *p = NULL;
+    char *left = NULL;
+    char *right = NULL;
 
     left = right = NULL;
@@ -1510,101 +1543,108 @@
     return RP_OK;
 }
+*/
 
 //FIXME: commented out because it calls Rp_TreeGetArrayValue
-//int
-//Rp_TreeGetValue(
-//    TreeClient *clientPtr,
-//    Node *nodePtr,
-//    CONST char *string,     /* String identifying the field in node. */
-//    void **objPtrPtr)
-//{
-//    char *left, *right;
-//    int result;
-//
+int
+Rp_TreeGetValue(
+    TreeClient *clientPtr,
+    Node *nodePtr,
+    CONST char *string,     /* String identifying the field in node. */
+    void **objPtrPtr)
+{
+    char *left = NULL;
+    char *right = NULL;
+    int result;
+
+// uncomment after Rp_TreeGetArrayValue is fixed
 //    if (ParseParentheses(string, &left, &right) != TCL_OK) {
 //        return TCL_ERROR;
 //    }
-//    if (left != NULL) {
-//        *left = *right = '\0';
-//        result = Rp_TreeGetArrayValue(clientPtr, nodePtr, string, left + 1, objPtrPtr);
-//        *left = '(', *right = ')';
-//    } else {
-//        result = Rp_TreeGetValueByKey(clientPtr, nodePtr,
-//                    Rp_TreeGetKey(string), objPtrPtr);
-//    }
-//    return result;
-//}
+    if (left != NULL) {
+        *left = *right = '\0';
+        // result = Rp_TreeGetArrayValue(clientPtr, nodePtr, string, left + 1, objPtrPtr);
+        *left = '(', *right = ')';
+    } else {
+        result = Rp_TreeGetValueByKey(clientPtr, nodePtr,
+                    Rp_TreeGetKey(string), objPtrPtr);
+    }
+    return result;
+}
 
 //FIXME: commented out because it calls Rp_TreeSetArrayValue
-//int
-//Rp_TreeSetValue(
-//    TreeClient *clientPtr,
-//    Node *nodePtr,          /* Node to be updated. */
-//    CONST char *string,     /* String identifying the field in node. */
-//    void *valueObjPtr)      /* New value of field. If NULL, field
-//                             * is deleted. */
-//{
-//    char *left, *right;
-//    int result;
-//
+int
+Rp_TreeSetValue(
+    TreeClient *clientPtr,
+    Node *nodePtr,          /* Node to be updated. */
+    CONST char *string,     /* String identifying the field in node. */
+    void *valueObjPtr)      /* New value of field. If NULL, field
+                             * is deleted. */
+{
+    char *left = NULL;
+    char *right = NULL;
+    int result;
+
+// uncomment after Rp_TreeSetArrayValue is fixed
 //    if (ParseParentheses(string, &left, &right) != RP_OK) {
 //        return RP_ERROR;
 //    }
-//    if (left != NULL) {
-//        *left = *right = '\0';
-//        result = Rp_TreeSetArrayValue(clientPtr, nodePtr, string, left + 1, valueObjPtr);
-//        fprintf(stderr, "Rp_TreeSetArrayValue not supported\n", name);
-//
-//        *left = '(', *right = ')';
-//    } else {
-//        result = Rp_TreeSetValueByKey(clientPtr, nodePtr,
-//                    Rp_TreeGetKey(string), valueObjPtr);
-//    }
-//    return result;
-//}
+    if (left != NULL) {
+        *left = *right = '\0';
+        //result = Rp_TreeSetArrayValue(clientPtr, nodePtr, string, left + 1, valueObjPtr);
+        *left = '(', *right = ')';
+    } else {
+        result = Rp_TreeSetValueByKey(clientPtr, nodePtr,
+                    Rp_TreeGetKey(string), valueObjPtr);
+    }
+    return result;
+}
 
 //FIXME: commented out because it calls Rp_TreeUnsetArrayValue
-//int
-//Rp_TreeUnsetValue(
-//    TreeClient *clientPtr,
-//    Node *nodePtr,          /* Node to be updated. */
-//    CONST char *string)     /* String identifying the field in node. */
-//{
-//    char *left, *right;
-//    int result;
-//
+int
+Rp_TreeUnsetValue(
+    TreeClient *clientPtr,
+    Node *nodePtr,          /* Node to be updated. */
+    CONST char *string)     /* String identifying the field in node. */
+{
+    char *left = NULL;
+    char *right = NULL;
+    int result;
+
+// uncomment after Rp_TreeUnsetArrayValue is fixed
 //    if (ParseParentheses(string, &left, &right) != RP_OK) {
 //        return RP_ERROR;
 //    }
-//    if (left != NULL) {
-//        *left = *right = '\0';
-//        result = Rp_TreeUnsetArrayValue(clientPtr, nodePtr, string, left + 1);
-//        *left = '(', *right = ')';
-//    } else {
-//        result = Rp_TreeUnsetValueByKey(clientPtr, nodePtr, Rp_TreeGetKey(string));
-//    }
-//    return result;
-//}
+    if (left != NULL) {
+        *left = *right = '\0';
+        // result = Rp_TreeUnsetArrayValue(clientPtr, nodePtr, string, left + 1);
+        *left = '(', *right = ')';
+    } else {
+        result = Rp_TreeUnsetValueByKey(clientPtr, nodePtr, Rp_TreeGetKey(string));
+    }
+    return result;
+}
 
 //FIXME: commented out because it calls Rp_TreeArrayValueExists
-//int
-//Rp_TreeValueExists(TreeClient *clientPtr, Node *nodePtr, CONST char *string)
-//{
-//    char *left, *right;
-//    int result;
-//
+int
+Rp_TreeValueExists(TreeClient *clientPtr, Node *nodePtr, CONST char *string)
+{
+    char *left = NULL;
+    char *right = NULL;
+    int result;
+
+// uncomment after Rp_TreeArrayValueExists is fixed
 //    if (ParseParentheses(string, &left, &right) != RP_OK) {
 //        return FALSE;
 //    }
-//    if (left != NULL) {
-//        *left = *right = '\0';
-//        result = Rp_TreeArrayValueExists(clientPtr, nodePtr, string, left + 1);
-//        *left = '(', *right = ')';
-//    } else {
-//        result = Rp_TreeValueExistsByKey(clientPtr, nodePtr,
-//                Rp_TreeGetKey(string));
-//    }
-//    return result;
-//}
+    if (left != NULL) {
+        *left = *right = '\0';
+        // result = Rp_TreeArrayValueExists(clientPtr, nodePtr, string, left + 1);
+        *left = '(', *right = ')';
+    } else {
+        result = Rp_TreeValueExistsByKey(clientPtr, nodePtr,
+                Rp_TreeGetKey(string));
+    }
+    return result;
+}
 
 Rp_TreeKey
@@ -1955,4 +1995,32 @@
 //    return RP_OK;
 //}
+
+int
+Rp_TreeGetTokenFromToken(
+    TreeClient *fromClientPtr, // old client from which to base the new client
+    TreeClient **clientPtrPtr) // new client
+{
+    TreeClient *clientPtr;
+    TreeObject *treeObjPtr;
+
+    if (fromClientPtr == NULL) {
+        fprintf(stderr, "can't create new token from null token\n");
+        return RP_ERROR;
+    }
+
+    treeObjPtr = fromClientPtr->treeObject;
+    if (treeObjPtr == NULL) {
+        fprintf(stderr, "can't find a tree object based on provided client\n");
+        return RP_ERROR;
+    }
+    clientPtr = NewTreeClient(treeObjPtr);
+    if (clientPtr == NULL) {
+        fprintf(stderr, "can't allocate token for tree \"%s\"",
+            treeObjPtr->name);
+        return RP_ERROR;
+    }
+    *clientPtrPtr = clientPtr;
+    return RP_OK;
+}
 
 void
@@ -3031,5 +3099,5 @@
             RebuildTable(nodePtr);
         }
-        } else {
+    } else {
         Value *prevPtr;
 
Index: /trunk/src/objects/RpTree.h
===================================================================
--- /trunk/src/objects/RpTree.h	(revision 1559)
+++ /trunk/src/objects/RpTree.h	(revision 1560)
@@ -192,5 +192,6 @@
 
     unsigned int nChildren; /* # of children for this node. */
-    unsigned int inode;     /* Serial number of the node. */
+    // unsigned int inode;     /* Serial number of the node. */
+    size_t inode;           /* Serial number of the node. */
 
     unsigned short depth;   /* The depth of this node in the tree. */
@@ -281,5 +282,5 @@
         Rp_TreeNode parent, CONST char *name, int position));
 EXTERN Rp_TreeNode Rp_TreeCreateNodeWithId _ANSI_ARGS_((Rp_Tree tree,
-        Rp_TreeNode parent, CONST char *name, int position, int inode));
+        Rp_TreeNode parent, CONST char *name, size_t inode, int position));
 
 EXTERN int Rp_TreeDeleteNode _ANSI_ARGS_((Rp_Tree tree, Rp_TreeNode node));
@@ -288,8 +289,10 @@
         Rp_TreeNode parent, Rp_TreeNode before));
 
-EXTERN Rp_TreeNode Rp_TreeGetNode _ANSI_ARGS_((Rp_Tree tree,
-        unsigned int inode));
+EXTERN Rp_TreeNode Rp_TreeGetNode _ANSI_ARGS_((Rp_Tree tree, size_t inode));
 
 EXTERN Rp_TreeNode Rp_TreeFindChild _ANSI_ARGS_((Rp_TreeNode parent,
+        CONST char *name));
+
+EXTERN Rp_TreeNode Rp_TreeFindChildNext _ANSI_ARGS_((Rp_TreeNode child,
         CONST char *name));
 
@@ -391,4 +394,7 @@
         Rp_TreeApplyProc *proc, ClientData clientData));
 
+EXTERN int Rp_TreeApplyXML _ANSI_ARGS_((Rp_TreeNode root,
+        Rp_TreeApplyProc *proc, ClientData clientData));
+
 EXTERN int Rp_TreeSortNode _ANSI_ARGS_((Rp_Tree tree, Rp_TreeNode node,
         Rp_TreeCompareNodesProc *proc));
@@ -399,6 +405,9 @@
 // EXTERN int Rp_TreeExists _ANSI_ARGS_((CONST char *name));
 
-EXTERN int Rp_TreeGetToken _ANSI_ARGS_((CONST char *name,
-        Rp_Tree *treePtr));
+// EXTERN int Rp_TreeGetToken _ANSI_ARGS_((CONST char *name,
+//         Rp_Tree *treePtr));
+
+EXTERN int Rp_TreeGetTokenFromToken _ANSI_ARGS_((
+        CONST Rp_Tree tree, Rp_Tree *newToken));
 
 EXTERN void Rp_TreeReleaseToken _ANSI_ARGS_((Rp_Tree tree));
